/* ȿñ㲻ġ
 * shige
 * 02/28 2001
 * aiffhz.c
 *
 * $Id: aiffhz.c,v 1.4 2002-02-19 23:21:34+09 shige Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifdef __hpux
# include <values.h>
#endif
#include "aiffio.h"

#define POS8bit 0
#define SCALE8bit 125.0
#define POS16bit 0
#define SCALE16bit 32764.0
#define USESINEWAVE

int main(int argc,char *argv[]);
void putsound(FILE *outfile,AIFFdata *wd,int hz,double vol);
double periodic(double x);
void usage(void);

int main(int argc,char *argv[])
{
    FILE *outfile=stdout;
    int hz,len,ch,bit;
    double vol;
    defdouble sample;
    AIFFdata ad;

    if(argc!=6+1 ||(hz=atoi(argv[1]))<0
       ||(len=atoi(argv[2]))<=0
       ||(vol=atof(argv[3]))<0.0 || vol>1.0
       ||(sample=atof(argv[4]))<=0
       ||((ch=atoi(argv[5]))<=0 && ch>6)
       ||((bit=atoi(argv[6]))!=8 && bit!=16)){ 
        /* AIFF   bit = 24,32  support Ƥ뤱ɤǤ
	 * support ʤ
	 */
	usage();
	return 0;
    }
    ad.channel=ch;
    ad.smplrate.x=sample;
    ConvertToIeeeExtended(sample,ad.smplrate.s);
    ad.bitpersmpl=bit;
    ad.flamesize=bit*ch/8;
    ad.flames=(int)(sample*len/1000.0+0.5);
    ad.datalen=ad.flames*ad.flamesize;
    putsound(outfile,&ad,hz,vol);
    return 0;
}

/* hz Hz, len ߥäβ volume level vol ή
 * hz == 0 ==> ̵
 */
void putsound(FILE *outfile,AIFFdata *ad,int hz,double vol)
{
    int j,k;
    unsigned char c;
    short int y;

    putallAIFFheader(outfile,ad,1);
    if(hz==0 || vol==0.0){
	if(ad->bitpersmpl==8){
	    for(j=1;j<=ad->datalen;j++) fputc(AIFF8NULL,outfile);
	    if(ad->datalen%2) fputc('\0',outfile);
	}
	else
	  for(j=1;j<=ad->datalen/2;j++) 
	    writeito2byte(outfile,AIFF16NULL);
    }
    else{
	if(ad->bitpersmpl==8){
	    for(j=1;j<=ad->flames;j++){
		c=vol*periodic(j*hz/(ad->smplrate).x)*SCALE8bit+POS8bit;
		for(k=1;k<=ad->channel;k++) 
		  fputc(c,outfile);
	    }
	    if(ad->datalen%2) fputc('\0',outfile);
	}
	else{
	    for(j=1;j<=ad->flames;j++){
		y=vol*periodic(j*hz/(ad->smplrate).x)*SCALE16bit+POS16bit;
		for(k=1;k<=ad->channel;k++) 
		  writeito2byte(outfile,y);
	    }
	}
    }
}

#ifdef USESINEWAVE
/*  1,  -1.0~1.0
 */
double periodic(double x)
{
    return sin(2.0*M_PI*x);
}
#else
double periodic(double x)
{
    int j;

    j=x;
    return x-j;
}
#endif

void usage(void)
{
    char *mess[]={
	"Usage: aiffhz [Hz] [msec] [vol] [smpl] [ch] [bit] (> [newfile])",
	" [Hz]  : ñ㲻ι⤵   (ȿ)",
	" [msec]: ñ㲻Ĺ   (ߥ)",
	" [vol] : ñ㲻礭 (0.0~1.0)",
	" [smpl]: AIFF եΥץ󥰼ȿ (44100.0(Hz) ʤ)",
	" [ch]  : AIFF եΥͥ (1(Υ), 2(ƥ쥪))",
	" [bit] : AIFF ե bit Ĺ (8, 16)",
	"Ex. aiffhz 440 500 0.7 44100.0 1 16 > poo.aiff",
	" ==> 440Hz (), 0.5 äβ򥵥ץ󥰼ȿ 44100.0Hz,",
	"     Υ, ̻Ҳӥå 16bit Ǻ",
	" 1) Ϥɸϡ",
	" 2) [Hz] == 0 ޤ [vol] == 0 Ȥ̵Υǡ롣",
#ifdef USESINEWAVE
	" 3) ñ㲻ϻȤѤ롣",
#else
	" 3) ñ㲻ϥΥȤѤ롣",
#endif
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}
