/* AIFF file ôʬ
 * shige
 * 10/29 2000
 * aiffio.c
 *
 * $Id: aiffio.c,v 1.6 2003-12-22 23:37:50+09 shige Exp $
 */
#ifndef __AIFFIO_C__
#define __AIFFIO_C__

#include "aiffio.h"

#undef DEBUG2

/* aiff file  header μ */
int getAIFFheader(FILE *file,AIFFdata *ad)
{
    long int j;
    long int size,csize;
    int pass=0;

    fseek(file,0,SEEK_SET);
    /* magic */
#ifdef DEBUG2
    fprintf(stderr,"Pass 1.\n");
#endif
    if(read4bytetoi(file,&j)<0 || j != sto4bytei("FORM")
       || read4bytetoi(file,&size)<0 || size < 8
       || read4bytetoi(file,&j)<0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    size+=8;
#ifdef DEBUG2
    fprintf(stderr,"Pass 2.\n");
#endif
    /* chunk θ */
    while(pass<2){
	if(ftell(file)>size-8) break;
#ifdef DEBUG2
	fprintf(stderr,"Pass 3-1.\n");
#endif
	if(read4bytetoi(file,&j)<0 || read4bytetoi(file,&csize)<0)
	  return Err_readaiffheader;	
#ifdef DEBUG2
	fprintf(stderr,"Pass 3-2.\n");
#endif
	if(j == sto4bytei("COMM")){ /* Common chunk */
#ifdef DEBUG2
	    fprintf(stderr,"Pass 4-1.\n");
#endif
	    if(csize!=AIFFCOMMCHUNKSIZE /* AIFF only */
	       || read2bytetoi(file,&(ad->channel))<0 
	       || ad->channel<1 || ad->channel >6
	       || read4bytetoi(file,&(ad->flames))<0
	       || read2bytetoi(file,&(ad->bitpersmpl))<0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file,&(ad->smplrate))<0)
	      return Err_readaiffheader;
#ifdef DEBUG2
	    fprintf(stderr,"Pass 4-2.\n");
#endif
	    ad->flamesize=(ad->channel)*(ad->bitpersmpl)/8;
	    pass++;
	}
	else if(j == sto4bytei("SSND")){ /* Sound data chunk */
#ifdef DEBUG2
	    fprintf(stderr,"Pass 5-1.\n");
#endif
	    ad->datalen=csize;
	    if(ad->datalen<8
	       || read4bytetoi(file,&j)<0 || j!=0
	       || read4bytetoi(file,&j)<0 || j!=0)
	      return Err_readaiffheader;
#ifdef DEBUG2
	    fprintf(stderr,"Pass 5-2.\n");
#endif
	    ad->datalen-=8;
	    ad->hlen=ftell(file);
	    fseek(file,ad->datalen,SEEK_CUR);
	    pass++;
	}
	else if(csize>0) fseek(file,csize,SEEK_CUR); /* skip only */
#ifdef DEBUG2
	fprintf(stderr,"Pass 6.\n");
#endif
	if(csize%2) fseek(file,1,SEEK_CUR);
    }
#ifdef DEBUG2
    fprintf(stderr,"Pass 7.\n");
#endif
    if(pass<2) return Err_readaiffheader;
#ifdef DEBUG2
    fprintf(stderr,"Pass 8.\n");
#endif
    if(ad->datalen/ad->flamesize!=ad->flames) return Err_readaiffheader;
#ifdef DEBUG2
    fprintf(stderr,"Pass 9.\n");
#endif
    return No_err;
}

/* aiff file  header μ & chunk list κ */
int getAIFFinfo(FILE *file,AIFFdata *ad,Chunk *Ch)
{
    long int j;
    long int size;
    int pass=0;
    Chunk *ch;
    int chunks=0;

    fseek(file,0,SEEK_SET);
#ifdef DEBUG2
    fprintf(stderr,"Pass 1.\n");
#endif
    /* magic */
    if(read4bytetoi(file,&j)<0 || j != sto4bytei("FORM")
       || read4bytetoi(file,&size)<0 || size < 8
       || read4bytetoi(file,&j)<0 || j != sto4bytei("AIFF"))
      return Err_readaiffheader;
    size+=8;
#ifdef DEBUG2
    fprintf(stderr,"Pass 2.\n");
#endif
    /* chunk θ */
    while(1){
	if(ftell(file)>size-8) break;
#ifdef DEBUG2
	fprintf(stderr,"Pass 3-1. (ftell=%ld, size-8=%ld)\n",
		ftell(file),size-8);
#endif
	if(++chunks>Maxchunks) return Err_too_many_chunks;
#ifdef DEBUG2
	fprintf(stderr,"Pass 3-2.\n");
#endif
	ch=&(Ch[chunks-1]);
	ch->start=ftell(file);
	if(fread(ch->id,4,1,file)<1 || read4bytetoi(file,&(ch->size))<0)
	  return Err_readaiffheader;
#ifdef DEBUG2
	fprintf(stderr,"Pass 3-3.\n");
#endif
	if(strncmp(ch->id,"COMM",4)==0){ /* Common chunk */
#ifdef DEBUG2
	    fprintf(stderr,"Pass 4-1.\n");
#endif
	    if(ch->size!=AIFFCOMMCHUNKSIZE /* AIFF only */
	       || read2bytetoi(file,&(ad->channel))<0 
	       || ad->channel<1 || ad->channel>6
	       || read4bytetoi(file,&(ad->flames))<0
	       || read2bytetoi(file,&(ad->bitpersmpl))<0 
	       || (ad->bitpersmpl)%8
	       || readAIFFExtended(file,&(ad->smplrate))<0)
	      return Err_readaiffheader;
#ifdef DEBUG2
	    fprintf(stderr,"Pass 4-2.\n");
#endif
	    ad->flamesize=(ad->channel)*(ad->bitpersmpl)/8;
	    pass++;
	}
	else if(strncmp(ch->id,"SSND",4)==0){ /* Sound data chunk */
#ifdef DEBUG2
	    fprintf(stderr,"Pass 5-1.\n");
#endif
	    ad->datalen=ch->size;
	    if(ad->datalen<8
	       || read4bytetoi(file,&j)<0 || j!=0
	       || read4bytetoi(file,&j)<0 || j!=0)
	      return Err_readaiffheader;
#ifdef DEBUG2
	    fprintf(stderr,"Pass 5-2.\n");
#endif
	    ad->datalen-=8;
	    ad->hlen=ftell(file);
	    fseek(file,ad->datalen,SEEK_CUR);	
	    pass++;
	}
	else if(ch->size>0) fseek(file,ch->size,SEEK_CUR); /* skip only */
#ifdef DEBUG2
	fprintf(stderr,"Pass 6.\n");
#endif
	if((ch->size)%2) fseek(file,1,SEEK_CUR);
    }
#ifdef DEBUG2
    fprintf(stderr,"Pass 7.\n");
#endif
    if(pass<2) return Err_readaiffheader;
#ifdef DEBUG2
    fprintf(stderr,"Pass 8.\n");
#endif
    if(ad->datalen/ad->flamesize!=ad->flames) return Err_readaiffheader;
#ifdef DEBUG2
    fprintf(stderr,"Pass 9.\n");
#endif
    return chunks;
}

/* AIFF header  */
int chAIFFheader(AIFFdata *ad1,AIFFdata *ad2)
{
    if(ad1->channel != ad2->channel) return Err_diffchannel;
    if(ad1->bitpersmpl != ad2->bitpersmpl) return Err_diffbitpersmpl;
    if(chAIFFExtended(&(ad1->smplrate),&(ad2->smplrate)))
      return Err_diffsmplrate;
    if(ad1->flamesize != ad2->flamesize) return Err_diffblocksize;
    return No_err;
}

/* AIFF ad[] Ĥʤ file  header ν */
void putallAIFFheader(FILE *file,AIFFdata *ad,int N)
{
    int j;
    long int flames=0L,datalen;

    writeito4byte(file,sto4bytei("FORM"));
    for(j=1;j<=N;j++) flames+=ad[j-1].flames;
    datalen=flames*ad[0].flamesize;
    if(datalen%2) datalen++;
    writeito4byte(file,4+8+AIFFCOMMCHUNKSIZE+8+8+datalen);
    writeito4byte(file,sto4bytei("AIFF"));
    /* COMM chunk */
    writeito4byte(file,sto4bytei("COMM"));
    writeito4byte(file,AIFFCOMMCHUNKSIZE);
    writeito2byte(file,ad[0].channel);
    writeito4byte(file,flames);
    writeito2byte(file,ad[0].bitpersmpl);
    writeAIFFExtended(file,&(ad[0].smplrate));
    /* SSND chunk */
    writeito4byte(file,sto4bytei("SSND"));
    writeito4byte(file,flames*ad[0].flamesize+8);
    writeito4byte(file,0L);
    writeito4byte(file,0L);
    /*  SSND data Ϥơɬפʤ 1 byte dummy Ĥ */
}

/* Ĺ */
void putallAIFFheader2(FILE *file,AIFFdata *ad,int N,int len,int addsp)
{
    int j;
    long int flames=0L,datalen;

    writeito4byte(file,sto4bytei("FORM"));
    for(j=1;j<=N;j++)
      flames+=(len>0 && (ad[j-1].flames>=len ||addsp))?len:ad[j-1].flames;
    datalen=flames*ad[0].flamesize;
    if(datalen%2) datalen++;
    writeito4byte(file,4+8+AIFFCOMMCHUNKSIZE+8+8+datalen);
    writeito4byte(file,sto4bytei("AIFF"));
    /* COMM chunk */
    writeito4byte(file,sto4bytei("COMM"));
    writeito4byte(file,AIFFCOMMCHUNKSIZE);
    writeito2byte(file,ad[0].channel);
    writeito4byte(file,flames);
    writeito2byte(file,ad[0].bitpersmpl);
    writeAIFFExtended(file,&(ad[0].smplrate));
    /* SSND chunk */
    writeito4byte(file,sto4bytei("SSND"));
    writeito4byte(file,flames*ad[0].flamesize+8);
    writeito4byte(file,0L);
    writeito4byte(file,0L);
}

/* Ĺ + Ψ */
void putallAIFFheader3(FILE *file,AIFFdata *ad,int N,int len,int addsp,
		       double times)
{
    int j;
    long int flames=0L,datalen,Nlen;

    writeito4byte(file,sto4bytei("FORM"));
    for(j=1;j<=N;j++){
	Nlen=(times>0.0)? ad[j-1].flames/times:ad[j-1].flames;
	flames+=(len>0 && (addsp||Nlen>=len))?len:Nlen;
    }
    datalen=flames*ad[0].flamesize;
    if(datalen%2) datalen++;
    writeito4byte(file,4+8+AIFFCOMMCHUNKSIZE+8+8+datalen);
    writeito4byte(file,sto4bytei("AIFF"));
    /* COMM chunk */
    writeito4byte(file,sto4bytei("COMM"));
    writeito4byte(file,AIFFCOMMCHUNKSIZE);
    writeito2byte(file,ad[0].channel);
    writeito4byte(file,flames);
    writeito2byte(file,ad[0].bitpersmpl);
    writeAIFFExtended(file,&(ad[0].smplrate));
    /* SSND chunk */
    writeito4byte(file,sto4bytei("SSND"));
    writeito4byte(file,flames*ad[0].flamesize+8);
    writeito4byte(file,0L);
    writeito4byte(file,0L);
}

void putallAIFFheader4(FILE *file,AIFFdata *ad,int N,ConnOpt *opt)
{
    int j;
    long int flames=0L,datalen,Nlen;
    int len,addsp;
    double times;

    writeito4byte(file,sto4bytei("FORM"));
    for(j=1;j<=N;j++){
	len=opt[j-1].len; addsp=opt[j-1].addsp; times=opt[j-1].times;
	Nlen=(times>0.0)? ad[j-1].flames/times:ad[j-1].flames;
	flames+=(len>0 && (addsp||Nlen>=len))?len:Nlen;
    }
    datalen=flames*ad[0].flamesize;
    if(datalen%2) datalen++;
    writeito4byte(file,4+8+AIFFCOMMCHUNKSIZE+8+8+datalen);
    writeito4byte(file,sto4bytei("AIFF"));
    /* COMM chunk */
    writeito4byte(file,sto4bytei("COMM"));
    writeito4byte(file,AIFFCOMMCHUNKSIZE);
    writeito2byte(file,ad[0].channel);
    writeito4byte(file,flames);
    writeito2byte(file,ad[0].bitpersmpl);
    writeAIFFExtended(file,&(ad[0].smplrate));
    /* SSND chunk */
    writeito4byte(file,sto4bytei("SSND"));
    writeito4byte(file,flames*ad[0].flamesize+8);
    writeito4byte(file,0L);
    writeito4byte(file,0L);
}

/* olen: ºݤνĹ, times: Ψ (times>0)
 */
void puttransAIFF(FILE *infile,FILE *outfile,AIFFdata *ad,int olen,double times)
{
    long int j;
    int dlen,abs=ad->flamesize,ach=ad->channel;
    int k,count=0;
    short int x0[AIFFMAXChannel],x[AIFFMAXChannel];
    char x80[AIFFMAXChannel],x8[AIFFMAXChannel];
    double t=0.0;

    if(times<0.0){
	putfile2file(infile,outfile,ad->hlen,olen*abs);
	return;
    }
    dlen=ad->datalen/abs;
    fseek(infile,ad->hlen,SEEK_SET);
    if(abs/ach==1){ /* 8bit */
	for(k=1;k<=ach;k++) x80[k-1]=fgetc(infile);
	for(j=2;j<=dlen;j++){
	    for(k=1;k<=ach;k++)	x8[k-1]=fgetc(infile);
	    while(t<=1.0){
		for(k=1;k<=ach;k++) fputc(x80[k-1]*(1.0-t)+x8[k-1]*t,outfile);
		if(++count>=olen) return;
		t+=times;
	    }
	    t-=1.0;
	    for(k=1;k<=ach;k++) x80[k-1]=x8[k-1];
	}
	for(;count<=olen;count++) for(k=1;k<=ach;k++) fputc(x8[k-1],outfile);
    }
    else{ /* 16bit */
	for(k=1;k<=ach;k++) read2bytetoi(infile,&x0[k-1]);
	for(j=2;j<=dlen;j++){
	    for(k=1;k<=ach;k++)	read2bytetoi(infile,&x[k-1]);
	    while(t<=1.0){
		for(k=1;k<=ach;k++)
		  writeito2byte(outfile,x0[k-1]*(1.0-t)+x[k-1]*t);
		if(++count>=olen) return;
		t+=times;
	    }
	    t-=1.0;
	    for(k=1;k<=ach;k++) x0[k-1]=x[k-1];
	}
	for(;count<=olen;count++) 
	  for(k=1;k<=ach;k++) writeito2byte(outfile,x[k-1]);
    }
}

/* ########## for "extended" floating point routine ########## */
/* AIFF  sampling rate  80bit IEEE long double (== extended) */ 
int readAIFFExtended(FILE *file,Extended *Ex)
{
    if(fread(Ex->s,IEEEExtendedBytes,1,file)<1) return Err_fread;
    Ex->x = ConvertFromIeeeExtended(Ex->s);
    return No_err;
}

int writeAIFFExtended(FILE *file,Extended *Ex)
{
    int j;

    for(j=1;j<=IEEEExtendedBytes;j++) fputc(*(Ex->s+j-1),file);
    return No_err;
}

int chAIFFExtended(Extended *Ex1,Extended *Ex2)
{
    int j;

    for(j=1;j<=IEEEExtendedBytes;j++)
      if(*(Ex1->s+j-1)!=*(Ex2->s+j-1)) return 1;
    return 0;
}

#endif /* __AIFFIO_C__ */
