/* script interpreter 
 * 
 * shige
 * 05/13 2000
 * 06/02 2000
 * shless.c
 *
 * $Id: shless.c,v 1.5 2002-02-14 00:06:22+09 shige Exp $
 */
/* 05/13 2000
 * 1)	괺ñ 1 Ԥ system Ǽ¹Ԥ롣
 * 2)	backscroll 褦ˤ
 * 3)	key Ϥϼ괺
 * 4)	key bind: 
 *        [space], ñ return, 'n': ==> ι
 *        'r': ==> ι
 *        'b': ==> ι
 *        'q': ==> λ
 *	Ǥ '3b' ߤʤΤⰷ褦ˤ
 * 5)	Ϥ less ˶ŤФline ɡ
 * 	[a] buffering ʤ stdin Ȥäȿ夲
 *	[b] comand line βɽ
 *	[c] ϥβɽ
 *	==> [b],[c] ϼ
 * 6)	ϡƹԤɽĤġȿžɽȤäꤷʤ롢ä
 *	Τɤʤ (w3m  buffer Τ褦)ɽ⥳
 *	ɥ饤षѴιԤΤޤޤåϥ
 *	餷礦ʤ
 * 06/02 2000
 * 7)	fpurge()  Solaris ˤϤʤ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef __FreeBSD__
# include <unistd.h>
#endif

#define BUFFERCLEAR

#ifndef KEYDEV
# define KEYDEV "/dev/tty"
#endif

#define Maxbuff 8192
#define Maxlines 1000
#define CommStart '#'
#define ShlessComm "#shless:"
#define Maxcomm 80

enum Errorval {
    Err_too_long_line = -30,
    Err_too_many_lines,

    No_err=0,
};

#ifdef __FreeBSD__
# define FFLUSH(s) fpurge(s)
#else
# define FFLUSH(s) fflush(s)
#endif

/*####### prototype #######*/
int main(int argc,char *argv[]);
int getkey(char *c,int *num);
void mysystem(FILE *infile,long int lp[],long int cp[],int pos,
	      int vmode,int cmode,int rmode,int lmode);
char *commstr(FILE *infile,long int pos);
int mklinespos(FILE *infile,long int linespos[],long int shcommpos[]);
void usage(char *str,int mes);

int main(int argc,char *argv[])
{
    long int linespos[Maxlines],shcommpos[Maxlines];
    int lines,pos,j=1,num;
    char c,c0;
    FILE *infile;
    int vmode=1,cmode=0,rmode=1,lmode=1;

    /* command line argument */
    if(argc<2){ usage(NULL,1);	return 1; }
    if((c0=*argv[j])=='-' || c0=='+'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'v': vmode=(c0=='-')?1:0; break;
	    case 'c': cmode=(c0=='-')?1:0; break;
	    case 'x': rmode=(c0=='-')?1:0; break;
	    case 'l': lmode=(c0=='-')?1:0; break;
	    case '\0':
		if(c0=='+'){ usage("Unknown option.\n",1); return 1; }
		else break;
	    default: usage("Unknown option.\n",1); return 1;
	    }
	    if(c=='\0'){ argv[j]--; break; } /* stdin */
	    if((c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc){ usage(NULL,1); return 1; }
	    if((c0=*argv[j])!='-' && c0!='+') break;
	    c=*(++argv[j]);
	}
    }

    /* file open */
    if(*argv[j]=='-'){
	if((infile=tmpfile())==NULL){
	    usage("File open error.\n",1);
	    return 1;
	}
	while((j=fgetc(stdin))!=EOF) fputc(j,infile);
	if(freopen(KEYDEV,"r",stdin)==NULL){
	    usage("File open error.\n",1);
	    return 1;
	}
    }
    else if((infile=fopen(argv[j],"r"))==NULL){
	usage("File open error.\n",1);
	return 1;
    }

    /* ƹԤΰ֤ */
    if((lines=mklinespos(infile,linespos,shcommpos))<0)
      switch(lines){
      case Err_too_long_line: usage("Too long line exists.\n",0); return 1;
      case Err_too_many_lines: usage("Too many lines exist.\n",0); return 1;
      default: usage("Unknown error.\n",0); return 1;
      }
#ifdef DEBUG1
    {
	int j;
	for(j=1;j<=lines;j++){
	    printf("[%d]shlesscomm=%ld(%s),",j,shcommpos[j-1],
		   (shcommpos[j-1]>=0)?commstr(infile,shcommpos[j-1]):"NULL");
	    printf("linespos=%ld(%s)\n",linespos[j-1],
		   (linespos[j-1]>=0)?commstr(infile,linespos[j-1]):"NULL");
	}
	return 0;
    }
#endif

    /* ¹ */
    pos=1; /* 򺣼¹Ԥ () ȻפȤˤ */
    fseek(infile,0L,SEEK_SET);
    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);    
    while(1){
	if((j=getkey(&c,&num))==0) return 0;
	else if(j==-1){ usage("Unknown key.\n",0); continue; }
	switch(c){
	case 'q':
	case 'Q':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    else return 0;
	case 'r':
	case 'R':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    if(pos==0){ usage("TOP of the file.\n",0); break; }
	    else if(pos>lines){ usage("BOTTOM of the file.\n",0); break; }
	    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);
	    break;
	case 'b':
	case 'B':
	case 'p':
	case 'P':
	    if(num<0) num=1;
	    if(pos-num<1){ pos=0; usage("TOP of the file.\n",0); break; }
	    pos-=num;
	    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);
	    break;
	case 'n':
	case 'N':
	    if(num<0) num=1;
	    if(pos+num>lines){
		pos=lines+1; usage("BOTTOM of the file.\n",0); break;
	    }
	    pos+=num;
	    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);
	    break;
	case ' ':
	case '\n':
	    if(++pos>lines){
		pos=lines+1; usage("BOTTOM of the file.\n",0); break;
	    }
	    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);
	    break;
	case 'g':
	    if(num>0){
		if((pos=num)>lines){
		    pos=lines+1; usage("BOTTOM of the file.\n",0); break;
		}
	    }
	    else pos=1;
	    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);
	    break;
	case 'G':
	    if(num>0){ 
		if((pos=lines-num+1)<1){
		    pos=0; usage("BOTTOM of the file.\n",0); break; 
		}
	    }
	    else pos=lines;
	    mysystem(infile,linespos,shcommpos,pos,vmode,cmode,rmode,lmode);
	    break;
	case 'h':
	case 'H':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    usage("ư:  ) r) n) b) g)ǽ G)Ǹ h)Help q)λ\n",0);
	    usage("ON/OFF: v)ɽ c) x)¹ l)ֹ\n",0);
	    usage("  n,b,g,G Ͽ˻\n",0);
	    break;
	case 'v':
	case 'V':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    if(vmode){ usage("command line display OFF\n",0); vmode=0; }
	    else{ usage("command line display ON\n",0); vmode=1; }
	    break;
	case 'c':
	case 'C':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    if(cmode){ usage("comment display OFF\n",0); cmode=0; }
	    else{ usage("comment display ON\n",0); cmode=1; }
	    break;
	case 'x':
	case 'X':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    if(rmode){ usage("command run OFF\n",0); rmode=0; }
	    else{ usage("command run ON\n",0); rmode=1; }
	    break;
	case 'l':
	case 'L':
	    if(num>0){ usage("Unknown key.\n",0); break; }
	    if(lmode){ usage("line number OFF\n",0); lmode=0; }
	    else{ usage("line number ON\n",0); lmode=1; }
	    break;
	default:
	    usage("Unknown key.\n",0);
	}
    }
    return 0;
}

/* 0: EOF, 1: No_err, -1: error */
int getkey(char *c,int *num)
{
    char buff[Maxcomm];
    int len;

    if(fgets(buff,Maxcomm,stdin)==NULL) return 0;
    *num=-1;
    len=strlen(buff);
    if(len<=1) *c=' ';
    else{
	*c=buff[len-2];
	if(len>2){
	    buff[len-2]='\0';
	    if((*num=atoi(buff))<=0) return -1;
	}
    }
#ifdef BUFFERCLEAR
    FFLUSH(stdin);
#endif
    return 1;
}

void mysystem(FILE *infile,long int lp[],long int cp[],int pos,
	      int vmode,int cmode,int rmode,int lmode)
{
    char buff[Maxcomm];
    
    if(cmode && cp[pos-1]>=0){
	if(lmode){ sprintf(buff,"[%d] ",pos); usage(buff,0); }
	usage(commstr(infile,cp[pos-1]),0);
    }
    if(vmode){
	if(lp[pos-1]>=0){
	    if(lmode){ sprintf(buff,"[%d] ",pos); usage(buff,0); }
	    usage(commstr(infile,lp[pos-1]),0);
	}
	else usage("\n",0);
    }
    if(rmode && lp[pos-1]>=0) system(commstr(infile,lp[pos-1]));
#ifdef DEBUG2
    printf("DEBUG2: commstr(infile,cp[%d-1])=%s\n",pos,
	   (cp[pos-1]>=0)?commstr(infile,cp[pos-1]):"NULL");
    printf("DEBUG2: commstr(infile,lp[%d-1])=%s\n",pos,
	   (lp[pos-1]>=0)?commstr(infile,lp[pos-1]):"NULL");
#endif
}

char *commstr(FILE *infile,long int pos)
{
    static char buff[Maxbuff];

    if(pos<0) return NULL;
    fseek(infile,pos,SEEK_SET);
    fgets(buff,Maxbuff,infile);
    return buff;
}

int mklinespos(FILE *infile,long int linespos[],long int shcommpos[])
{
    char buff[Maxbuff];
    int j,lines=0,len,len2,inshlesscomm=0;
    long int pos=0L;
    char *s;
    
    len2=strlen(ShlessComm);
    fseek(infile,0L,SEEK_SET);
    while(fgets(buff,Maxbuff,infile)!=NULL){
        if((len=strlen(buff))>=Maxbuff-1 && buff[Maxbuff-2]!='\n')
	  return Err_too_long_line;
	for(s=buff,j=0;j<len;s++,j++) if(!isspace(*s)) break;
	if(*s==CommStart){ /* comment  */
	    if(strncmp(s,ShlessComm,len2)==0){ /* #shless:  */
		if(!inshlesscomm && ++lines>Maxlines) 
		  return Err_too_many_lines;
		inshlesscomm=1;
		shcommpos[lines-1]=pos+j+len2;
#ifdef DEBUG1
		printf("shcommops[%d]=%ld\n",lines-1,pos+j+len2);
#endif
	    }
	    else if(inshlesscomm){ inshlesscomm=0; lines--; }
	}
	else{
	    if(!inshlesscomm){
		if(++lines>Maxlines) return Err_too_many_lines;
		shcommpos[lines-1]=-1;
#ifdef DEBUG1
		printf("shcommops[%d]=-1\n",lines-1);
#endif
	    }
	    else inshlesscomm=0;
	    if(*s=='\0') linespos[lines-1]=-1;
	    else linespos[lines-1]=pos+j;
#ifdef DEBUG1
	    printf("linespos[%d]=%ld\n",lines-1,(*s='\0')?-1L:pos+j);
#endif
	}
	pos+=len;
    }
    if(inshlesscomm) lines--;
    return lines;
}

void usage(char *str,int mes)
{
    FILE *outf;
    char *mess[]={
	"Usage: shless (-v|+v)(-c|+c)(-x|+x)(-l|+l) [script file]",
	"  -v/+v: command line ɽ/ɽ (default: ɽ)",
	"  -c/+c: \"#shless:\" Ԥˤ륳Ȥɽ/ɽ (default: ɽ)",
	"  -x/+x: script Ԥμ¹Ԥ򤹤/ʤ (default: )",
	"  -l/+l: ֹɽ/ɽ (default: ɽ)",
	"1) [script file]  \"-\" ΤȤɸϤɤ߹ࡣ",
	"2) [script file] γƹԤ system() Ǽ¹ԤΤߡ",
	"3) '#' ǻϤޤԤϥȹԤȤߤʤ\"#shless:\" ǻϤޤ",
	"   Ԥϡ³ʸ command line ɽʸ",
	"   ƻѤ (-c +v option )",
	"4) key bind: (ʲΥθ [return] Ǽ¹)",
	"    [space]: ι (ñ [return] ǤƱ)",
        "    r: ι",
        "    ([num])n: ([num] ) ι",
        "    ([num])b: ([num] ) ι",
        "    ([num])g: ǽ ( [num] ) ι",
        "    ([num])G: Ǹ ( [num] ) ι",
	"    h: ",
	"    v,c,x,l: ȥ륹å (¹ԻץƱ)",
        "    q: λ",
	NULL
    };
    int j;

    if(isatty(fileno(stdout))) outf=stdout;
    else outf=stderr;  /* stdout  redirect Ƥ */ 

    if(str!=NULL) fprintf(outf,"%s",str);
    if(mes)
      for(j=0;mess[j]!=NULL;j++) fprintf(outf,"%s\n",mess[j]);
}
